/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-1
Name        : matrix.h
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-27v1.0
Description : Matrix erstellen
==================================================================================================*/
#ifndef MATRIX_H
#define	MATRIX_H

/**
 * Creates a matrix by a given number of rows and a given number of columns.
 * The matrix is filled with the values given by the third parameter.
 * Note: Don't forget to dealloc space after using!
 *
 * @param rows Number of rows for the matrix
 * @param cols Number of columns for the matrix
 * @param value Initialization value of the cells
 * @return <rows> x <cols> matrix filled with <value>
 * @see freeMatrix(int **matrix, int rows, int cols)
 */
int **createMatrix(int rows, int cols, int value);

/**
 * Filles a previously created matrix with a given value.
 *
 * @param matrix The matrix to be filled
 * @param rows Number of rows of the matrix
 * @param cols Number of columns of the matrix
 * @param value Initialization value of the cells
 * @return nothing
 */
void fillMatrix(int **matrix, int rows, int cols, int value);

/**
 * Prints a previously created matrix to the standard output
 *
 * @param matrix The matrix to be printed
 * @param rows Number of rows for the matrix
 * @param cols Number of columns for the matrix
 * @return nothing
 */
void printMatrix(int *const *matrix, int rows, int cols);

/**
 * Deallocates previously reserved memory
 *
 * @param matrix The matrix to deallocate
 * @param rows Number of rows for the matrix
 * @return <rows> x <cols> matrix filled with <value>
 */
void freeMatrix(int **matrix, int rows);

#endif	/* MATRIX_H */

